<template>
  <div class="card columns">
    <div class="card-header">
      <h3>Friends and Shares</h3>
    </div>
    <div class="card-body">
      <div class="row">
        <div class="col-md-7">
          <label for="Friend request">Send a friend request</label>
          <div class="input-group mb-3">
            <input
              v-model="friendMail"
              type="text"
              class="form-control"
              placeholder="input friend email"
              aria-label="Friend request"
            >
            <div class="input-group-append">
              <button
                class="btn btn-info btn-sm"
                type="button"
                id="button-addon2"
                @click="friendRequest()"
              >Send</button>
            </div>
          </div>
          <form>
            <div class="form-group">
              <label for="Servers">Servers</label>
              <select class="form-control" @change="changeServer()" v-model="selectedServer">
                <template v-if="servers.length>0 || serversOffline.length>0">
                  <template v-for="(server, key) in servers">
                    <option :key="key" :value="server" v-if="user.id==server.userId">{{server.name}}</option>
                  </template>
                  <template v-for="(serverOff, key) in serversOffline">
                    <option disabled :key="key+'off'" :value="serverOff" v-if="user.id==serverOff.userId" class="text-danger">
                      {{serverOff.name}}
                      <span>(offline)</span>
                    </option>
                  </template>
                </template>
              </select>
            </div>

            <label for="Libraries">Libraries</label>
            <template v-if="selectedServer">
              <template v-if="libraries.length>0">
                <ul class="list-group list-group-flush p-0 m-0">
                  <template v-for="(library, key) in libraries">
                    <li class="list-group-item pt-1 pb-1" :key="key">
                      {{library.name}}
                      <label class="switch p-0 m-0 float-right">
                        <input
                          :checked="sharedLibraries.includes(library._id)"
                          type="checkbox"
                          class="primary m-0 p-0"
                          @click="selectLibrary($event,library)"
                        >
                        <span class="slider m-0 p-0"></span>
                      </label>
                    </li>
                  </template>
                </ul>
              </template>
              <div v-else>No libraries in {{selectedServer.name}}</div>
            </template>
          </form>
        </div>
        <div class="col-md-5 friend-selector mt-3">
          <div class="card friend-selector">
            <div class="card-header p-1 pl-2">
              <h5 class="card-title p-0 m-0">My friends
                <span  class="float-right btn" data-trigger="hover | focus" data-toggle="popover"  data-content="Break friendship" @click.stop="()=>{if(selectedFriend)$modal.show('modalConfirm')}">
                      <font-awesome-icon color="firebrick" icon="trash-alt" />
                </span>
                <!-- unfriend -->
                <modal-confirm action="delLibrary" @delLibrary="response=>friendshipEnd(selectedFriend,response)">
                  <template>Library
                    <span v-if="selectedFriend" class="text-danger">{{selectedFriend.name}}</span> and you will stop being friends
                  </template>
                </modal-confirm>
              </h5>
            </div>
            <div class="card-body friend-selector m-0 p-2">
              <div class="list-group">
                <template v-for="(friend,key) in friends">
                  <a
                    :key="key"
                    @click="selectFriend(friend)"
                    class="list-group-item list-group-item-action p-1 friend btn"
                    :class="{friendSelected:friend==selectedFriend}"
                  >
                    <div class="p-0 row">
                      <div class="col-2 col-md-5">
                        <div class>
                          <userImage size="sm" class="p-0 mr-auto" :user="friend"></userImage>
                        </div>
                      </div>
                      <div
                        class="p-0 col-10 col-md-7 d-flex align-items-center justify-content-start"
                      >
                        <span class="text-truncate">{{friend.name}}</span>
                      </div>
                    </div>
                  </a>
                </template>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import modalConfirm from "../modals/ModalConfirm"
import userImage from "../userImage";
import EventBus from "../../main";
export default {
  props: ["user"],
  components: {
    userImage,
    modalConfirm
  },
  beforeDestroy(){
    this.$socket.off('resFriendship')
    EventBus.$off('frienshipAccepted')
  },
  mounted: function() {
    this.$socket.on("destroyFrienship",friend=>{this.deleteFriend(friend)})
    this.$socket.emit("reqServers", {
      token: localStorage.getItem("jwt"),
      userId: this.user.id
    });
    this.$socket.emit("reqFriends", {
      token: localStorage.getItem("jwt"),
      userId: this.user.id
    });

    this.$socket.on("resServers", servers => {
      servers.forEach(server => {
        if (server.isConected && server.userId==this.user.id) this.servers.push(server);
        else if(server.userId==this.user.id) this.serversOffline.push(server);
      });
      if (this.servers.length > 0) {
        this.selectedServer = servers[0];
        this.reqLibraries();
      }
    });
    this.$socket.on("resFriends", friends => {
      this.friends = friends;
      if (this.friends.length > 0) this.selectFriend(this.friends[0]);
    });
    EventBus.$on("frienshipAccepted", friend => {
      this.friends.push(friend);
      if (this.friends.length == 1) this.selectFriend(this.friends[0]);
    });
    this.$socket.on("resFriendship", data => {
      if (data.accepted) {
        this.friends.push(data.friend);
        if (this.friends.length == 1) this.selectFriend(this.friends[0]);
      }
    });
    this.$socket.on("resFriend", data => {
      if (data.created) {
      } else {
        var mesaje = data.friend + " is not the mail of any myreads user";
        if (typeof data.friend == "object")
          mesaje = data.friend.email + " is already requested";
        this.$toastr.error(mesaje, "Request error", {
          preventDuplicates: true,
          progressBar: true,
          positionClass: "toast-bottom-right"
        });
      }
    });

    this.$socket.on("resLibraries", libraries => {
      this.libraries = libraries;
      //console.log(this.selectedFriend.name + ' ' + this.selectedServer.name)
      if (this.selectedFriend && this.selectedServer) this.reqSharedLibraries();
    });
    this.$socket.on("resSharedLibraries", data => {
      //console.log("shared" + data);
      if (data) this.sharedLibraries = data;
      else this.sharedLibraries = [];
    });
    this.$socket.on("serverUpdateStatus", data => {
      if (data.status) {
        this.servers.push(data.server);
        this.serversOffline.splice(this.serversOffline.indexOf(data.server));
        if (this.servers.length == 1) {
          this.selectedServer = this.servers[0];
          this.reqLibraries();
        } else {
          if (this.servers.length == 0) {
            this.libraries = [];
          }
        }
        this.$toastr.info(
          "Server " + data.server.name + " is now online",
          "Server Connected",
          {
            preventDuplicates: true,
            progressBar: true,
            positionClass: "toast-bottom-right"
          }
        );
      } else {
        if (data.server.id == this.selectedServer.id) {
          this.selectedServer = this.servers[0];
          this.reqLibraries();
        }
        this.serversOffline.push(data.server);
        this.servers.splice(this.servers.indexOf(data.server));
        if (this.servers.length == 0) this.libraries = [];
        this.$toastr.error(
          "Server " + data.server.name + " is now offline",
          "Server Dissconnected",
          {
            preventDuplicates: true,
            progressBar: true,
            positionClass: "toast-bottom-right"
          }
        );
      }
    });
  },
  data() {
    return {
      selectedServer: null,
      servers: [],
      serversOffline: [],
      sharedLibraries: [],
      libraries: [],
      friends: [],
      selectedFriend: null,
      friendMail: ""
    };
  },
  methods: {
    reqLibraries() {
      if (this.selectedServer) {
        this.$socket.emit("reqLibraries", {
          token: localStorage.getItem("jwt"),
          user: this.user,
          server: this.selectedServer
        });
      }
    },
    selectLibrary(event, library) {
      let data = {
        token: localStorage.getItem("jwt"),
        user: this.user,
        library: library,
        server: this.selectedServer,
        friend: this.selectedFriend
      };
      if (event.target.checked) data.add = true;
      else data.add = false;
      this.$socket.emit("updateSharedLibraries", data);
    },
    changeServer() {
      this.libraries = [];
      this.reqLibraries();
    },
    friendRequest() {
      if (this.friendMail.length > 0 && this.validate_email(this.friendMail)) {
        this.$socket.emit("reqFriend", {
          email: this.friendMail,
          token: localStorage.getItem("jwt"),
          user: this.user
        });
        this.friendMail = "";
      } else {
        var message;
        if (this.friendMail.length === 0) message = "The field email is void";
        else message = "Plese type a valid email";
        this.$toastr.error(message, "Mail error", {
          preventDuplicates: true,
          progressBar: true,
          positionClass: "toast-bottom-right"
        });
      }
    },
    selectFriend(friend) {
      this.selectedFriend = friend;
      this.reqSharedLibraries();
    },
    reqSharedLibraries() {
      this.sharedLibraries = [];
      if (this.selectedServer && this.selectFriend)
        this.$socket.emit("reqSharedLibraries", {
          token: localStorage.getItem("jwt"),
          user: this.user,
          friend: this.selectedFriend,
          server: this.selectedServer
        });
    },
    validate_email(email) {
      var regex = /^([a-zA-Z0-9_\.\-])+\@(([a-zA-Z0-9\-])+\.)+([a-zA-Z0-9]{2,4})+$/;
      return regex.test(email) ? true : false;
    },
    friendshipEnd(friend,response){
      if(response){
        this.$socket.emit("reqEnFrienship",{
          user: this.user,
          token: localStorage.getItem("jwt"),
          friend: friend
        })
        this.deleteFriend(friend)
      }
    },
    deleteFriend(friend){
      this.friends.splice(this.friends.indexOf(friend),1)
      if (this.friends.length>0) this.selectFriend(this.friends[0])
      else this.selectedFriend=null
    }
  },
};
</script>

<style scoped>
/* The switch - the box around the slider */
.switch {
  position: relative;
  display: inline-block;
  width: 50px;
  height: 23px;
}

/* Hide default HTML checkbox */
.switch input {
  display: none;
}

/* The slider */
.slider {
  position: absolute;
  cursor: pointer;
  top: 0;
  left: 0;
  right: 0;
  bottom: 0;
  background-color: #ccc;
  -webkit-transition: 0.4s;
  transition: 0.4s;
}

.slider:before {
  position: absolute;
  content: "";
  height: 15px;
  width: 16px;
  left: 4px;
  bottom: 4px;
  background-color: white;
  -webkit-transition: 0.4s;
  transition: 0.4s;
}

input.default:checked + .slider {
  background-color: #444;
}
input.primary:checked + .slider {
  background-color: #2196f3;
}

input:focus + .slider {
  box-shadow: 0 0 1px #2196f3;
}

input:checked + .slider:before {
  -webkit-transform: translateX(26px);
  -ms-transform: translateX(26px);
  transform: translateX(26px);
}

.friend-selector {
  position: relative;
  height: 100% !important;
}
.friendSelected {
  background-color: lightskyblue;
}
.friend:hover {
  background-color: lightblue;
}
</style>
